--
-- Specialization doorOpenerK744R4
--
-- @Author  	Aluha74rus
-- @version 	v1.0
-- @date  		04/09/19

doorOpenerK744R4 = {};

doorOpenerK744R4.modDir = g_currentModDirectory;

function doorOpenerK744R4.prerequisitesPresent(specializations)
    return 
    SpecializationUtil.hasSpecialization(InteractiveControl, specializations)
end;

function doorOpenerK744R4.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", doorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", doorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", doorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", doorOpenerK744R4)
end
function doorOpenerK744R4:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection)
	if isActiveForInputIgnoreSelection  then
		if self.ActionEvents == nil then 
			self.ActionEvents = {}
		else	
			self:clearActionEventsTable( self.ActionEvents )
		end 
		for _,actionName in pairs({ "LEFT_DOOR_OPENER"} ) do
			local _, eventName = self:addActionEvent(self.ActionEvents, InputAction[actionName], self, doorOpenerK744R4.actionEventleftDoor, true, true, false, true, nil);
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventName] ~= nil and self.kapot.plIR then
				if isActiveForInputIgnoreSelection then
					g_inputBinding.events[eventName].displayPriority = 1
				elseif  isActiveForInputIgnoreSelection then
					g_inputBinding.events[eventName].displayPriority = 2
				end
				g_inputBinding.events[eventName].displayIsVisible = true
			end
		end
	end
end
function doorOpenerK744R4:actionEventleftDoor(actionName, keyStatus, arg4, arg5, arg6)
	if self:getIsActiveForInput(true, true) then
		if keyStatus > 0 then
			if actionName == 'LEFT_DOOR_OPENER' then
				self.leftDoorOpen = true
			end
		elseif keyStatus == 0 then
			if actionName == 'LEFT_DOOR_OPENER' then
				self.leftDoorOpen = false
			end
		end
	end
end
function doorOpenerK744R4.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "playerCallbackKapot",  doorOpenerK744R4.playerCallbackKapot)
end
function doorOpenerK744R4:onLoad(savegame)
    self.leftDoorOpen = false
    -- self.playerCallbackKapot = doorOpenerK744R4.playerCallbackKapot; 
	
	self.kapot = {};
	
	local trigger = I3DUtil.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.triggers.kapot#trigger")) );
	if trigger == nil then
		print("[Error::kapot] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.triggers.kapot#icIndex", i));
	
	self.kapot.icIndex = icIndex;
	self.kapot.trigger = trigger;
	self.kapot.plIR = false;
	
	addTrigger( trigger, "playerCallbackKapot", self );
end;

function doorOpenerK744R4:onDelete()
	if self.kapot.trigger ~= nil then
		removeTrigger(self.kapot.trigger);
	end;
end

function doorOpenerK744R4:onUpdate(dt)
    -- if getIsActiveForInput then
	    -- if self.leftDoorOpen then
			-- local obj = self.interactiveObjects[self.kapot.icIndex];
			-- if obj ~= nil then
				-- self:doActionOnObject(self.kapot.icIndex);
			-- end;
		-- end
	-- end;
	-- if self.kapot.plIR then
		-- setTextColor(1.0, 1.0, 1.0, 1.0);
		-- setTextAlignment(RenderText.ALIGN_LEFT); 				
		-- renderText( 0.5, 0.06, 0.02, g_i18n:getText("Input_Kapot_Close") );
		-- if self.leftDoorOpen then
			-- local obj = self.interactiveObjects[self.kapot.icIndex];
			-- if obj ~= nil then
				-- self:doActionOnObject(self.kapot.icIndex);
			-- end;
	    -- end;
	-- end;
	-- if self.kapot.plIR then
		-- setTextColor(1.0, 1.0, 1.0, 1.0);
		-- setTextAlignment(RenderText.ALIGN_LEFT); 				
		-- renderText( 0.5, 0.06, 0.02, g_i18n:getText("Input_Kapot_Close") );
		-- if isActiveForInputIgnoreSelection then
		-- if self.leftDoorOpen then
			-- local obj = self.interactiveObjects[self.kapot.icIndex];
			-- if obj ~= nil then
				-- self:doActionOnObject(self.kapot.icIndex);
			-- end;
		-- end
	    -- end;
	-- end;
	
	
	if self.kapot.plIR and  Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT)then
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("Input_Kapot_Close") );
    end;
	if self.kapot.plIR and  Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT)then
        local obj = self.interactiveObjects[self.kapot.icIndex];
        if obj ~= nil then
			self:doActionOnObject(self.kapot.icIndex);
		end;
    end;
end;

function doorOpenerK744R4:playerCallbackKapot(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		self.kapot.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		self.kapot.plIR = false;
	end;
end;