--
-- Specialization doorOpenerK744R4
--
-- @Author  	Aluha74rus
-- @version 	v1.0
-- @date  		04/09/19

doorOpenerK744R4 = {};

doorOpenerK744R4.modDir = g_currentModDirectory;

function doorOpenerK744R4.prerequisitesPresent(specializations)
    return true; 
end;

function doorOpenerK744R4.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", doorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", doorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", doorOpenerK744R4)
end
function doorOpenerK744R4.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "playerCallbackKapot",  doorOpenerK744R4.playerCallbackKapot)
    SpecializationUtil.registerFunction(vehicleType, "playerCallbackLeftDoor",  doorOpenerK744R4.playerCallbackLeftDoor)
end
function doorOpenerK744R4:onLoad(savegame)
	self.kapot = {};
	
	local trigger = I3DUtil.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.triggers.kapot#trigger")) );
	if trigger == nil then
		print("[Error::kapot] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.triggers.kapot#icIndex", i));
	
	self.kapot.icIndex = icIndex;
	self.kapot.trigger = trigger;
	self.kapot.plIR = false;
	
	addTrigger( trigger, "playerCallbackKapot", self );
	
	self.leftDoor = {};
	
	local trigger = I3DUtil.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.triggers.leftDoor#trigger")) );
	if trigger == nil then
		print("[Error::leftDoor] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.triggers.leftDoor#icIndex", i));
	
	self.leftDoor.icIndex = icIndex;
	self.leftDoor.trigger = trigger;
	self.leftDoor.plIR = false;
	
	addTrigger( trigger, "playerCallbackLeftDoor", self );
end;

function doorOpenerK744R4:onDelete()
	if self.kapot.trigger ~= nil then
		removeTrigger(self.kapot.trigger);
	end;
	if self.leftDoor.trigger ~= nil then
		removeTrigger(self.leftDoor.trigger);
	end;
end

function doorOpenerK744R4:onUpdate(dt)
	if self.kapot.plIR then
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("Input_Kapot_Close") );
    end;
	if self.leftDoor.plIR then
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("Input_LedtDoor_Close") );
    end;
	if self.kapot.plIR and Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT)then
        local obj = self.interactiveObjects[self.kapot.icIndex];
        if obj ~= nil then
			self:doActionOnObject(self.kapot.icIndex);
		end;
		self.kapot.plIR = false;
    end;
	if self.leftDoor.plIR and Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT)then
        local obj = self.interactiveObjects[self.leftDoor.icIndex];
        if obj ~= nil then
			self:doActionOnObject(self.leftDoor.icIndex);
		end;
		self.leftDoor.plIR = false;
    end;
end;

function doorOpenerK744R4:playerCallbackKapot(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		self.kapot.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		self.kapot.plIR = false;
	end;
end;

function doorOpenerK744R4:playerCallbackLeftDoor(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		self.leftDoor.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherActorId == g_currentMission.player.rootNode then
		self.leftDoor.plIR = false;
	end;
end;